#!/usr/bin/env bash

#phys-429	KaaS Management cluster
#	cz10149
#	Managed cluster - control plane
#	cz10147
#	cz10148
#	cz7788
#	Managed cluster - worker/storage
#	cz808
#	cz809
#	cz810
#	cz811
#	cz10150
#	cz10151
echo 'set_power'

declare -A nodes_pw
nodes_pw=(\
[cz10149]='PM3dqFFwe3fe' \
[cz10150]='PM3dqFFwe3fe' \
[cz10151]='PM3dqFFwe3fe' \
[cz10147]='PM3dqFFwe3fe' \
[cz10148]='PM3dqFFwe3fe' \
[cz7788]='PM3dqFFwe3fe' \
[cz808]='cWuaU8gRXVKA' \
[cz809]='cWuaU8gRXVKA' \
[cz810]='cWuaU8gRXVKA' \
[cz811]='cWuaU8gRXVKA' \
)

function set_power(){
  local action="${1:-'chassis power status'}"
  local nset=${2:-'all'}
  declare -A nodes=();
  declare -A nodes_child=();
  declare -A nodes_mgmt=();

  nodes_child=([cz10147]='5.43.229.155' [cz10148]='5.43.229.156' \
               [cz7788]='5.43.225.124'  [cz808]='176.74.219.187' \
               [cz809]='176.74.219.189' [cz810]='176.74.219.190' [cz811]='176.74.219.207' \
               [cz10150]='5.43.229.158' [cz10151]='5.43.229.159' )

  nodes_mgmt=([cz10149]='5.43.229.157')
  # awesome merge event...
  case "$nset" in
      'mgmt')
        for i in ${!nodes_mgmt[@]}; do
            nodes[$i]="${nodes_mgmt[$i]}"
        done
      ;;
      'child')
        for i in ${!nodes_child[@]}; do
            nodes[$i]="${nodes_child[$i]}"
        done
      ;;
      'all')
        for i in ${!nodes_child[@]}; do
            nodes[$i]="${nodes_child[$i]}"
        done
        for i in ${!nodes_mgmt[@]}; do
            nodes[$i]="${nodes_mgmt[$i]}"
        done
      ;;
  esac

  for i in "${!nodes[@]}"; do
    echo "node: $i"
    set -xe
    ipmitool -I lanplus -H ${nodes[$i]} -U engineer -P "${nodes_pw[$i]}" $action
    set +xe
  done
 }

